#!/bin/bash

##################################################
# PSXC-IMDB-FIND
################
#
# An addon to psxc-imdb.
# Please read the README, then edit config below.
#
# History:
# v0.1  Initial Release
# v2.3  Added a bit more fuzzy search
#       Changed lookup url
#       Added timeout setting to wget
#       Did a jump in version number, since this
#        script is now a part of psxc-imdb.
#       Added better control on arguments passed.
# v2.3f Added support for iMDB IDs.
##################################################

########
# CONFIG

# Version. No need to change.
VERSION=2.3

# (full) path to psxc-imdb.conf
PSXC_IMDB_CONF=/glftpd/etc/psxc-imdb.conf

# END OF CONFIG
###############

IMDBSEARCHORIGA=`echo -n "$@" | tr -d ':\n\]\[}{'`
if [ -z "$IMDBSEARCHORIGA" ]; then
 echo "\002IMDB :\002 psxc-imdb channel trigger - use \002-fuzz\002 to make a fuzzy search."
 exit 0
fi
IMDBFUZZ=""
if [ ! -z "`echo $IMDBSEARCHORIGA | grep -e "\-[fF][uU][zZ][zZ]"`" ]; then
 IMDBFUZZ="&type=fuzzy"
fi
IMDBSEARCHORIG="`echo $IMDBSEARCHORIGA | tr ' ' '\n' | grep -v "^-" | tr ' ' '\n' | grep -v "^$" | tr '\n' ' '`"
if [ -z "$IMDBSEARCHORIG" ]; then
 echo "\002IMDB :\002 psxc-imdb channel trigger - please add something to search for."
 exit 0
fi
URLTOUSE=""
IMDBSEARCHWORDS="`echo $IMDBSEARCHORIG`"
IMDBSEARCHTITLE="`echo $IMDBSEARCHORIG | tr ' -' '+'`""$IMDBFUZZ"
if [ -z "`echo "$IMDBSEARCHTITLE" | tr -d '0-9\n '`" ]; then
 IMDBSEARCHID="`echo -n "$IMDBSEARCHTITLE" | tr -cd '0-9'`"
 if [ `echo -n "$IMDBSEARCHID" | wc -c` -ge 6 ] || [ `echo -n "$IMDBSEARCHID" | wc -c` -le 8 ]; then
  URLTOUSE="http://us.imdb.com/title/tt""$IMDBSEARCHID"
 fi
fi
. $PSXC_IMDB_CONF

if [ -z "$URLTOUSE" ]; then
 CONTENT=`lynx -dump -width=1000 -hiddenlinks=ignore -connect_timeout=10 http://us.imdb.com/Tsearch?title=$IMDBSEARCHTITLE`
 LINKNO=`echo "$CONTENT" | grep -e "\ 1\.\ " | head -n 1 | cut -d "[" -f 2 | cut -d "]" -f 1`
 if [ ! -z "$LINKNO" ]; then
  URLTOUSE=`echo "$CONTENT" | awk /eferences$/,/theendofthefile/ | grep -e "$LINKNO\.\ " | head -n 1 | tr ' ' '\n' | grep -e "imdb" | head -n 1`
 else
  URLTOUSE=""
 fi
 if [ -z "$URLTOUSE" ]; then
  WGETOUT=`wget -U "Internet Explorer" -O /dev/null --timeout=30 http://us.imdb.com/Tsearch?title=$IMDBSEARCHTITLE 2>&1`
  URLTOUSE=`echo "$WGETOUT" | tr ' ' '\n' | grep -e "imdb" | grep -i -e "\/title\/" | head -n 1`
 fi
fi
if [ ! -z "$URLTOUSE" ]; then
 echo "\002IMDB :\002 '$IMDBSEARCHWORDS' found @ \002$URLTOUSE\002. Please wait while formatting info.."
 echo "$URLTOUSE|/dev/null" | sed "s%/|%|%" >>$IMDBLOG
else
 echo "\002IMDB :\002 Sorry, nothing found on '\002$IMDBSEARCHWORDS\002'."
fi
exit 0
