#!/bin/bash

# This little thingy will install psxc-imdb

 
imdbredofiles () {
 echo ""
 echo "modifying files... please wait..."
  touch installer.tmp || { echo "could not create temp file in current dir. Exiting."; exit 1; };
  mkdir -p backup
  mkdir -p changedfiles
  EDITFILE=psxc-imdb.sh
  echo -n "$EDITFILE .. "
  if [ -e $EDITFILE ]; then
   cat $EDITFILE | sed "s|GLROOT=/glftpd|GLROOT=$GLROOT|" | sed "s|CONFFILE=/etc/psxc-imdb.conf|CONFFILE=$IMDB_CONF|" >installer.tmp
   cat installer.tmp >changedfiles/`basename $EDITFILE`
  else
   echo "could not find $EDITFILE. Exiting."
   exit 1
  fi
  EDITFILE=psxc-imdb.conf
  echo "done."
  echo -n "$EDITFILE .. "
  if [ -e $EDITFILE ]; then
   cat $EDITFILE | sed "s|GLROOT=/glftpd|GLROOT=$GLROOT|" >installer.tmp
   cat installer.tmp >changedfiles/`basename $EDITFILE`
  else
   echo "could not find $EDITFILE. Exiting."
   exit 1
  fi
  EDITFILE=psxc-imdb-conf.tcl
  echo "done."
  echo -n "$EDITFILE .. "
  if [ -e $EDITFILE ]; then
   cat $EDITFILE | sed "s|/glftpd/|$GLROOT/|g" >installer.tmp
   cat installer.tmp >changedfiles/`basename $EDITFILE`
  else
   echo "could not find $EDITFILE. Exiting."
   exit 1
  fi
  EDITFILE=extras/psxc-imdb-sanity.sh
  echo "done."
  echo -n "$EDITFILE .. "
  if [ -e $EDITFILE ]; then
   cat $EDITFILE | sed "s|GLROOT=/glftpd|GLROOT=$GLROOT|" | sed "s|CONFFILE=/etc/psxc-imdb.conf|CONFFILE=$IMDB_CONF|" >installer.tmp
   cat installer.tmp >changedfiles/`basename $EDITFILE`
  else
   echo "could not find $EDITFILE. Exiting."
   exit 1
  fi
  EDITFILE=extras/psxc-imdb-find.sh
  echo "done."
  echo -n "$EDITFILE .. "
  if [ -e $EDITFILE ]; then
   cat $EDITFILE | sed "s|PSXC_IMDB_CONF=/glftpd/etc/psxc-imdb.conf|PSXC_IMDB_CONF=$GLROOT$IMDB_CONF|" >installer.tmp
   cat installer.tmp >changedfiles/`basename $EDITFILE`
  else
   echo "could not find $EDITFILE."
  fi
  EDITFILE=addons/psxc-imdb-nuker.sh
  echo "done."
  echo -n "$EDITFILE .. "
  if [ -e $EDITFILE ]; then
   cat $EDITFILE | sed "s|GLROOT=/glftpd|GLROOT=$GLROOT|" | sed "s|IMDB_CONF=\$GLROOT/etc/psxc-imdb.conf|IMDB_CONF=\$GLROOT$IMDB_CONF|" | sed "s|GLFTPD_CONF=/glftpd/etc/psxc-imdb.conf|GLFTPD_CONF=$GLFTPD_CONF|" >installer.tmp
   cat installer.tmp >changedfiles/`basename $EDITFILE`
  else
   echo "could not find $EDITFILE."
  fi
  EDITFILE=addons/psxc-symlink-maker.sh
  echo "done."
  echo -n "$EDITFILE .. "
  if [ -e $EDITFILE ]; then
   cat $EDITFILE | sed "s|IMDB_CONF=/glftpd/etc/psxc-imdb.conf|IMDB_CONF=$GLROOT$IMDB_CONF|" >installer.tmp
   cat installer.tmp >changedfiles/`basename $EDITFILE`
  else
   echo "could not find $EDITFILE."
  fi
  EDITFILE=extras/psxc-imdb-rescan.sh
  echo "done."
  echo -n "$EDITFILE .. "
  if [ -e $EDITFILE ]; then
   NUKESTYLE="`cat $GLFTPD_CONF | grep -e "^nukedir_style" | awk '{print $2}' | tr '%' '\n' | head -n 1`"
   cat $EDITFILE | sed "s|\[NUKED\]-|$NUKESTYLE|" >installer.tmp
   cat installer.tmp >changedfiles/`basename $EDITFILE`
  else
   echo "could not find $EDITFILE."
  fi
  EDITFILE=psxc-imdb-bot.tcl
  echo "done."
  echo -n "$EDITFILE .. "
  if [ -e $EDITFILE ]; then
   cat $EDITFILE >installer.tmp
   cat installer.tmp >changedfiles/`basename $EDITFILE`
  else
   echo "could not find $EDITFILE."
  fi
  echo "done."
  rm installer.tmp
  echo "All changes done."
  echo ""
}

imdbcopybins () {
 BINSLIST="changedfiles/psxc-imdb.sh:755 changedfiles/psxc-imdb-find.sh:755 changedfiles/psxc-imdb-rescan.sh:755 changedfiles/psxc-imdb-sanity.sh:700 changedfiles/psxc-imdb-nuker.sh:755 changedfiles/psxc-symlink-maker.sh:755"
 echo "Copying bins .."
 for BINFILES in $BINSLIST; do
  BINFILE=`echo $BINFILES | cut -d ':' -f 1`
  BINMODE=`echo $BINFILES | cut -d ':' -f 2`
  echo -n "`basename $BINFILE` .. "
  if [ -e $GLROOT/bin/`basename $BINFILE` ]; then
   echo -n "backuping old file .. "
   cp $GLROOT/bin/`basename $BINFILE` backup/
  fi
  chmod $BINMODE $BINFILE
  mv $BINFILE $GLROOT/bin/`basename $BINFILE`
  echo "done."
 done
 echo ""
}

imdbcopyconf () {
 CONFSLIST="changedfiles/psxc-imdb.conf:644:$GLROOT$IMDB_CONF"
 echo "Copying conf .."
 for CONFFILES in $CONFSLIST; do
  CONFFILE=`echo $CONFFILES | cut -d ':' -f 1`
  CONFMODE=`echo $CONFFILES | cut -d ':' -f 2`
  CONFDEST=`echo $CONFFILES | cut -d ':' -f 3`
  echo -n "`basename $CONFFILE` .. "
  if [ -e $CONFDEST ]; then
   echo -n "backuping old file .. "
   cp $CONFDEST backup/
  fi
  chmod $CONFMODE $CONFFILE
  mv $CONFFILE $CONFDEST
  echo "done."
 done
 echo ""
}

imdbcopytcl () {
 TCLLIST="changedfiles/psxc-imdb-bot.tcl:644:$EGGPATH"
 echo "Copying tcl .."
 for TCLFILES in $TCLLIST; do
  TCLFILE=`echo $TCLFILES | cut -d ':' -f 1`
  TCLMODE=`echo $TCLFILES | cut -d ':' -f 2`
  TCLDEST=`echo $TCLFILES | cut -d ':' -f 3`
  echo -n "`basename $TCLFILE` .. "
  if [ -e $TCLDEST/`basename $TCLFILE` ]; then
   echo -n "backuping old file .. "
   cp $TCLDEST/`basename $TCLFILE` backup/
  fi
  chmod $TCLMODE $TCLFILE
  mv $TCLFILE $TCLDEST
 echo "done."
 done
}

imdbcopytclconf () {
 TCLLIST="changedfiles/psxc-imdb-conf.tcl:644:$EGGPATH"
 echo ""
 for TCLFILES in $TCLLIST; do
  TCLFILE=`echo $TCLFILES | cut -d ':' -f 1`
  TCLMODE=`echo $TCLFILES | cut -d ':' -f 2`
  TCLDEST=`echo $TCLFILES | cut -d ':' -f 3`
  echo -n "`basename $TCLFILE` .. "
  if [ -e $TCLDEST/`basename $TCLFILE` ]; then
   echo -n "backuping old file .. "
   cp $TCLDEST/`basename $TCLFILE` backup/
  fi
  chmod $TCLMODE $TCLFILE
  mv $TCLFILE $TCLDEST
 echo "done."
 done
 echo ""
}

imdbgrabconfs () {
 CONFFILELIST="backup/psxc-imdb-nuker.sh backup/psxc-symlink-maker.sh"
 touch backup/YOURCONFIG.txt
 echo ""
 echo "Extracting old configs .."
 for CONFFILE in $CONFFILELIST; do
  if [ -e $CONFFILE ]; then
  echo -n "`basename $CONFFILE` .. "
  ./extras/makeclean.sh $CONFFILE >>backup/YOURCONFIG.txt
  echo "done."
  fi
 done
 if [ -z backup/YOURCONFIG.txt ]; then
  rm backup/YOURCONFIG.txt
 fi
 echo ""
}

if [ ! -e README ] || [ ! -e UPGRADING ] || [ ! -e FILES ] || [ ! -d extras ] || [ ! -d addons ]; then
 echo "`dirname $0`"
 cd `dirname $0`
fi
if [ ! -e README ] || [ ! -e UPGRADING ] || [ ! -e FILES ] || [ ! -d extras ] || [ ! -d addons ]; then
 echo "Please start this script from within the installdir."
 exit 1
else
 if [ -z "$EDITOR" ]; then
  if [ ! -z "`which nano`" ]; then
   EDITOR="nano -w"
  elif [ ! -z "`which pico`" ]; then
   EDITOR="pico"
  elif [ ! -z "`which vi`" ]; then
   EDITOR="vi"
  else
   echo "No editor found. Please put the name of your"
   echo "favorite editor in the variable EDITOR"
   exit 1
  fi
 else
  EDITOR=`basename $EDITOR`
 fi
 if [ ! -z "`which less`" ]; then
  MYPAGER="`which less`"
 elif [ ! -z "`which more`" ]; then
  MYPAGER="`which more`"
 else
  MYPAGER="$EDITOR"
 fi
 MYSELECT=""
 while [ -z "$MYSELECT" ]; do
  clear
  echo "Welcome to PSXC-IMDB INSTALLER/UPGRADER."
  echo ""
  echo "This thingy will guide you through the installation/upgrading process."
  echo "For those new to psxc-imdb, I suggest you read README and FAQ,"
  echo "and make the appropriate changes in the config file(s) when asked."
  echo ""
  echo "Selections:"
  echo "1. Info on INSTALLING."
  echo "2. Info on UPGRADING."
  echo "3. Read README"
  echo "4. Read FAQ"
  echo "5. Read CHANGELOG"
  echo "6. Read UPGRADING"
  echo ""
  echo "9. Continue."
  echo ""
  echo -n "Your choice: [2]> "
  read line
  if [ "$line" = "1" ]; then
   echo ""
   echo "This script will make path-changes in each file's config section before"
   echo "copying the bin/tcl-scripts and the config file(s)."
   echo "Old files found/replaced will be backed up."
   echo "You will then be asked if you wish to make any changes to the config-"
   echo "files, using the editor '$EDITOR'. I suggest you do so. Take your time"
   echo "with this."
   echo "Afterwards, it will start the sanity-check, which will check that all"
   echo "binfiles and needed libs are present. It will also create and chmod the"
   echo "logfiles used."
   echo ""
   echo "Hit <return> to continue"
   read line
  elif [ "$line" = "2" ] || [ -z "$line" ]; then
   echo ""
   echo "This script will make path-changes in each file's config section before"
   echo "it will copy the bin/tcl-scripts. No changes will be made to"
   echo "psxc-imdb.conf or psxc-imdb-conf.tcl. The configs in the addons"
   echo "(psxc-symlink-maker.sh and psxc-imdb-nuker.sh) will be extracted before"
   echo "the files are replaced."
   echo "Old files found/replaced will be backed up."
   echo "If there are changes to the config file(s), I will try to patch them."
   echo "If the patching fails, the patch is undone."
   echo "If you use the addons, you will be asked if you wish to import your old"
   echo "config-settings into psxc-imdb.conf - anything here will override the"
   echo "default settings in the addons."
   echo "You will have the opportunity to edit the config-file(s) with the editor"
   echo "'$EDITOR'."
   echo "The sanity-checker will be started, to make sure everything is still"
   echo "working/looking good."
   echo ""
   echo "If you have made changes to the sources, I suggest you use the old method"
   echo "by patching the files, and not use this script."
   echo ""
   echo "Hit <return> to continue"
   read line
  elif [ "$line" = "3" ]; then
   $MYPAGER README
   echo ""
   echo "Hit <return> to continue"
   read line
  elif [ "$line" = "4" ]; then
   echo ""
   $MYPAGER FAQ
   echo ""
   echo "Hit <return> to continue"
   read line
  elif [ "$line" = "5" ]; then
   echo ""
   $MYPAGER CHANGELOG
   echo ""
   echo "Hit <return> to continue"
   read line
  elif [ "$line" = "6" ]; then
   echo ""
   $MYPAGER UPGRADING
   echo ""
   echo "Hit <return> to continue"
   read line
  elif [ "$line" = "9" ]; then
   echo ""
   echo ""
   MYSELECT="READY"
  fi
 done
 ITYPE="`ps ax | grep inetd`"
 ITYPE=`echo "$ITYPE" | grep -v "ps" | grep -v "grep" | tr ' ' '\n' | grep -e "inetd"`
 ITYPE=`basename $ITYPE`
 if [ "$ITYPE" = "inetd" ]; then
  if [ -e /etc/inetd.conf ]; then
   GLROOT="`cat /etc/inetd.conf | grep -e "^glftpd" | tr ' ' '\n' | grep -e "bin/glftpd" | head -n 1 | sed "s|/bin/glftpd||"`"
   if [ ! -z "$GLROOT" ]; then
    if [ ! -d $GLROOT ]; then
     GLROOT=""
    fi
    GLFTPD_CONF="`cat /etc/inetd.conf | grep -e "^glftpd" | grep -e "-r" | sed "s|-r |-r_|" | tr ' ' '\n' | grep -e "-r" | head -n 1 | sed "s|-r_||"`"
    if [ ! -z "$GLFTPD_CONF" ]; then
     if [ ! -e $GLFTPD_CONF ]; then
      GLFTPD_CONF=""
     fi
    fi
   fi
  fi
 elif [ "$ITYPE" = "xinetd" ]; then
  if [ -e /etc/xinetd.d/glftpd ]; then
   GLROOT="`cat /etc/xinetd.d/glftpd | grep -e "bin/glftpd" | tr ' ' '\n' | grep -e "bin/glftpd" | head -n 1 | sed "s|/bin/glftpd||"`"
   if [ ! -z "$GLROOT" ]; then
    if [ ! -d $GLROOT ]; then
     GLROOT=""
    fi
    GLFTPD_CONF="`cat /etc/xinetd.d/glftpd | grep -e "bin/glftpd" | grep -e "-r" | sed "s|-r |-r_|" | tr ' ' '\n' | grep -e "-r" | head -n 1 | sed "s|-r_||"`"
    if [ ! -z "$GLFTPD_CONF" ]; then
     if [ ! -e $GLFTPD_CONF ]; then
      GLFTPD_CONF=""
     fi
    fi
   fi
  fi
 fi
 if [ -z "$GLROOT" ]; then
  GLROOT="/glftpd"
 fi
 if [ -z "$GLFTPD_CONF" ]; then
  GLFTPD_CONF="/etc/glftpd.conf"
 fi

###
 ALLOK=""
 GLOK=""
 while [ -z "$ALLOK" ]; do
  while [ -z "$GLOK" ]; do
   echo -n "Please enter the installdir of glftpd [$GLROOT]> "
   read line
   if [ ! -z $line ]; then
    GLROOT="$line"
   fi
   echo -n "Please enter full path to glftpd.conf [$GLFTPD_CONF]> "
   read line
   if [ ! -z $line ]; then
    GLFTPD_CONF="$line"
   fi
   if [ -d $GLROOT ]; then
    if [ -e $GLFTPD_CONF ]; then
     GLOK="YES"
    fi
   fi
  done

###
  if [ -z "$IMDB_CONF" ]; then
   if [ -d $GLROOT/etc ]; then
    IMDB_CONF_NAME="`ls -1 $GLROOT/etc/ | grep -e "^psxc-imdb.conf$"`"
    if [ ! -z "$IMDB_CONF_NAME" ]; then
     IMDB_CONF="/etc/psxc-imdb.conf"
    fi
   fi
   if [ -d $GLROOT/bin ]; then
    IMDB_CONF_NAME="`ls -1 $GLROOT/bin/ | grep -e "^psxc-imdb.conf$"`"
    if [ ! -z "$IMDB_CONF_NAME" ]; then
     IMDB_CONF="/bin/psxc-imdb.conf"
    fi
   fi
   if [ -d $GLROOT ]; then
    IMDB_CONF_NAME="`ls -1 $GLROOT/ | grep -e "^psxc-imdb.conf$"`"
    if [ ! -z "$IMDB_CONF_NAME" ]; then
     IMDB_CONF="/psxc-imdb.conf"
    fi
   fi
   if [ -z "$IMDB_CONF" ]; then
    IMDB_CONF="/etc/psxc-imdb.conf"
   fi
  fi
  IMDBOK=""
  while [ -z "$IMDBOK" ]; do
   echo -n "Please enter relative path to psxc-imdb.conf [$IMDB_CONF]> "
   read line
   if [ ! -z $line ]; then
    IMDB_CONF="$line"
    if [ -z "`echo "$IMDB_CONF" | grep -e "psxc-imdb.conf$"`" ]; then
     IMDB_CONF="`echo "$IMDB_CONF""/psxc-imdb.conf" | tr -s '/'`"
    fi
   fi
   if [ -d `dirname $GLROOT$IMDB_CONF` ]; then
    IMDBOK="YES"
   else
    echo ""
    echo "The dir \"$GLROOT$IMDB_CONF\" do not exists."
   fi
  done
  EGGOK=""
  EGGPATH=""
  echo ""
  echo "Do you use a bot/eggdrop?"
  echo "If so, please enter the path to the eggdrop's scripts dir."
  echo "Hitting <enter> here will assume no bot is used, or that"
  echo "you wish to set this part up yourself."
  EGGPATH=""
  while [ -z "$EGGOK" ]; do
   echo -n "eggdrops's script dir: > "
   read line
   if [ ! -z $line ]; then
    if [ -d $line ]; then
     if [ ! -z "`ls -1 $line | grep -e ".tcl$"`" ]; then
      EGGPATH=$line
      EGGOK="OK"
     else
      echo "No tcl files found $line."
      echo -n "Are you sure you wish to use it? (y/n) [n]> "
      read anotherline
      if [ ! "$anotherline" = "y" ]; then
       EGGOK=""
      else
       EGGPATH=$line
       EGGOK="OK"
      fi
     fi
    else
     echo "Could not find a dir named $line"
    fi
   else
    EGGOK="OK"
   fi
  done
  echo ""
  echo "The following is used (full paths shown)"
  echo "glftpd install dir. . . . . : $GLROOT"
  echo "glftpd.conf . . . . . . . . : $GLFTPD_CONF"
  echo "psxc-imdb.conf installed in : $GLROOT$IMDB_CONF"
  if [ ! -z "$EGGPATH" ]; then
   echo "eggdrop's script dir. . . . : $EGGPATH"
  fi
  echo ""
  echo -n "Do this look okay to you? (y/n) [n]> "
  read line
  if [ "$line" = "y" ]; then
   ALLOK="OK"
  else
   GLOK=""
  fi
 done
 if [ -e "$GLROOT$IMDB_CONF" ]; then
  echo "It seems you have installed psxc-imdb already."
  echo -n "Do you wish to [u]pgrade or [i]nstall? [u]> "
  read line
  if [ "$line" = "i" ]; then
   echo -n "Really? Do a reinstall?? (y/n) [n]> "
   read line
   if [ "$line" = "y" ]; then
    INSTMODE="I"
   else
    INSTMODE="U"
   fi
  else
   INSTMODE="U"
  fi
 else
  INSTMODE="I"
 fi
 if [ "$INSTMODE" = "I" ]; then
  echo ""
  echo "PSXC-IMDB NEW INSTALL"
  echo "---------------------"
  echo "I am now ready to (re)install psxc-imdb."
  echo "Copies of the original files I find will be put it backup/"
  echo ""
  echo "To continue, hit <enter>, or <ctrl-c> to stop."
  read line
  imdbredofiles
  imdbcopybins
  imdbcopyconf
  echo ""
  echo -n "Do you wish to edit psxc-imdb.conf now? (y/n) [y]> "
  read line
  if [ ! "$line" = "n" ]; then
   $EDITOR $GLROOT$IMDB_CONF
  fi
  if [ ! -z "$EGGPATH" ]; then
   imdbcopytcl
   imdbcopytclconf
   echo ""
   echo -n "Do you wish to edit psxc-imdb-conf.tcl now? (y/n) [y]> "
   read line
   if [ ! "$line" = "n" ]; then
    $EDITOR $EGGPATH/psxc-imdb-conf.bot
   fi
  fi
  echo ""
  echo "Starting sanity-check"
  echo ""
  echo "Hit <return> to continue"
  read line
  $GLROOT/bin/psxc-imdb-sanity.sh
  echo ""
  echo "Done installing. Please make sure everything is set up okay."
  echo "All the original files are in backup/."
  echo "All the modified files not replaced is in /changedfiles. Here"
  echo "you also find other changes made/found."
  echo ""
  echo "-psxc"
  echo ""
 else
  echo ""
  echo "PSXC-IMDB UPGRADE"
  echo "-----------------"
  echo "I am now ready to upgrade psxc-imdb."
  echo "Copies of the original files I find will be put it backup/"
  echo "Changed config-files will be put in changedfiles/"
  echo "Please note that all bins will be replaced, not just the ones"
  echo "listen in UPGRADING."
  echo ""
  echo "To continue, hit <enter>, or <ctrl-c> to stop."
  echo "No changes to your original files will be done unless you approve."
  read line
  imdbredofiles
  echo ""
  echo "Hit <enter> to continue, or <s> to skip copying the bins."
  echo "There should only be need to skip this if you have made changes to"
  echo "the sources. Also keep in mind that all files found is backed up."
  read line
  if [ -z "$line" ]; then
   imdbcopybins
  else
   echo "skipping."
  fi
  if [ ! -z "$EGGPATH" ]; then
   echo ""
   echo "Hit <enter> to continue, or <s> to skip copying psxc-imdb-bot.tcl."
   read line
   if [ -z "$line" ]; then
    imdbcopytcl
   else
    echo "skipping"
   fi
  fi
  imdbgrabconfs
  if [ -e changedfiles/psxc-imdb.conf ]; then
   echo ""
   echo "PSXC-IMDB.CONF changes -"
   echo "Please take your time."
   if [ ! -z "`ls -1 diff/ | grep -e "psxc-imdb\.conf"`" ]; then
    echo "trying to patch a backup of your psxc-imdb.conf"
    echo ""
    cp changedfiles/psxc-imdb.conf changedfiles/psxc-imdb.conf.backup
    diffname=`ls -1 diff/ | grep -e "psxc-imdb\.conf"`
    patch -p1 changedfiles/psxc-imdb.conf < diff/$diffname
    if [ $? -eq 0 ]; then
     echo ""
     echo "That seemed to work."
     echo "Please note that this was only the patch tracking the"
     echo "difference from last publicly released version of the script."
    else
     cp changedfiles/psxc-imdb.conf.backup changedfiles/psxc-imdb.conf
     echo ""
     echo "That did not go well... patch is being undone."
     echo "Please make the appropriate changes yourself."
    fi
   fi
   if [ -e backup/YOURCONFIG.txt ]; then
    echo ""
    echo "Should I add the config-settings I found in the addon(s) you"
    echo -n "use into the bottom of psxc-imdb.conf? (y/n) [y]> "
    read line
    if [ ! "$line" = "n" ]; then
     echo "adding config settings.."
     cat backup/YOURCONFIG.txt >> changedfiles/psxc-imdb.conf
     echo "done."
    fi
   fi
   echo ""
   echo "Do you wish to make any changes to the config before I continue?"
   echo "You will get another question before I copy the config back -"
   echo "nothing has been done to your original config yet."
   echo -n "Edit config with '$EDITOR'? (y/n) [y]> "
   read line
   if [ ! "$line" = "n" ]; then
    $EDITOR changedfiles/psxc-imdb.conf
   else
    echo "skipping."
   fi
   echo ""
   echo "Are you happy with the changes? Should I replace the original"
   echo -n "psxc-imdb.conf with the modifies one? (y/n) [n] >"
   read line
   if [ ! "$line" = "y" ]; then
    echo "skipping."
    echo "You can find the changed config in changedfiles."
   else
    echo "replacing your original config"
    mv changedfiles/psxc-imdb.conf $GLROOT$IMDB_CONFIG
    echo "done"
   fi
  fi
  if [ -e changedfiles/psxc-imdb-conf.tcl ]; then
   echo ""
   echo "PSXC-IMDB-CONF.TCL changes -"
   echo "Please take your time."
   if [ ! -z "`ls -1 diff/ | grep -e "psxc-imdb-conf\.tcl"`" ]; then
    echo "trying to patch a backup of your psxc-imdb-conf.tcl"
    echo ""
    cp changedfiles/psxc-imdb.conf changedfiles/psxc-imdb.conf.backup
    diffname=`ls -1 diff/ | grep -e "psxc-imdb-conf\.tcl"`
    patch -p1 changedfiles/psxc-imdb-conf.tcl < diff/$diffname
    if [ $? -eq 0 ]; then
     echo ""
     echo "That seemed to work."
    else
     cp changedfiles/psxc-imdb-conf.tcl.backup changedfiles/psxc-imdb-conf.tcl
     echo ""
     echo "That did not go well... patch is being undone."
     echo "Please make the appropriate changes yourself."
    fi
   fi
   echo ""
   echo "Do you wish to make any changes to the config before I continue?"
   echo "You will get another question before I copy the config back -"
   echo "nothing has been done to your original config yet."
   echo -n "Edit config with '$EDITOR'? (y/n) [y]> "
   read line
   if [ ! "$line" = "n" ]; then
    $EDITOR changedfiles/psxc-imdb-conf.tcl
   else
    echo "skipping."
   fi
   echo ""
   echo "Are you happy with the changes? Should I replace the original"
   echo -n "psxc-imdb-conf.tcl with the modifies one? (y/n) [n] >"
   read line
   if [ ! "$line" = "y" ]; then
    echo "skipping."
    echo "You can find the changed config in changedfiles."
   else
    echo "replacing your original config"
    mv changedfiles/psxc-imdb-conf.tcl $EGGPATH
    echo "done"
   fi
  fi
  echo ""
  echo "Starting sanity-check"
  echo ""
  echo "Press <enter> to continue."
  read line
  $GLROOT/bin/psxc-imdb-sanity.sh
  echo ""
  echo "Done installing. Please make sure everything is set up okay."
  echo "All the original files are in backup/."
  echo "All the modified files not replaced is in /changedfiles. Here"
  echo "you also find other changes made/found."
  echo ""
  echo "-psxc"
  echo ""
 fi
 if [ -d backup ]; then
  mv backup packup.`date +%s`
 fi
 if [ -d changedfiles ]; then
  mv changedfiles changedfiles.`date +%s`
 fi
fi

